%define contentdir /home/httpd
%define modsslver 2.8.12-1.3.27
%define opensslver 0.9.6

Summary: The most widely used Web server on the Internet.
Name: apache
Version: 1.3.27
Release: 1.0.34
Group: System Environment/Daemons
Source0: ftp://ftp.apache.org/apache/dist/apache_%{version}.tar.gz
Source1: apache.logrotate
Source2: apache-httpd.conf-gd-2
Source3: apache-index.html
Source4: mod_ssl-%{modsslver}.tar.gz
Source5: httpd.init
Patch0: apache_1.3.14-mkstemp.patch
Patch1: apache-1.3.20-HARD-SERVER_LIMIT-gd.diff
Patch2: apache-1.3.27-htfixes-gd-1.diff
Patch3: apache-1.3.27-CAN-2003-0542-gd-1.diff
Copyright: Freely distributable and usable
Prereq: /sbin/chkconfig, /bin/sed, mailcap, grep, textutils,
Prereq: /usr/sbin/useradd, initscripts >= 5.20
Requires: /etc/mime.types, gawk
Provides: webserver
BuildPrereq: findutils, perl
BuildRequires: openssl
BuildRoot: %{_tmppath}/apache-root


### apache #####################################################################
%description
Apache is a powerful, full-featured, efficient and freely-available
Web server. Apache is also the most popular Web server on the
Internet.

Install the apache package if you need a Web server.


### apache-devel ###############################################################
%package devel
Group: Development/Libraries
Summary: Development tools for the Apache Web server.

%description devel
The apache-devel package contains the APXS binary and other files that
you'll need to build Dynamic Shared Objects (DSOs) for Apache.

If you are installing the Apache Web server, and you want to be 
able to compile or develop additional modules for Apache, you'll 
need to install this package.

%files devel
%defattr(0644,root,root)
%{_includedir}/apache
%doc %{_mandir}/man8/apxs.8*

%attr(0750,root,admin) %{_sbindir}/apxs


### apache-manual ##############################################################
%package manual
Group: Documentation
Summary: Documentation for the Apache Web server.

%description manual
The apache-manual package contains the complete manual and reference
guide for the Apache Web server.  If you need Apache documentation
installed on the local machine, install this package.  The information
can also be found on the Web at http://www.apache.org/docs/.

%files manual
%defattr(-,root,root)
%{contentdir}/html/manual


### Dir-T work #################################################################
%prep
%setup -q -n apache_%{version} -b 4
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1

%build
TARGET_PLATFORM=%{_target_platform}
%define _target_platform --target=${TARGET_PLATFORM}

export CFLAGS="%{optflags}" 
export LDFLAGS=-lpthread

### Configure mod_ssl into apache source tree.
cd $RPM_BUILD_DIR/mod_ssl-%{modsslver}
APACHE_SRC_DEFAULT=../apache_1.3.14/src
./configure \
      --with-perl=/usr/bin/perl \
      --with-apache=../apache_%{version} \
      --with-ssl=../openssl-%{opensslver} \
      --prefix=%{_prefix} \
      --exec-prefix=%{_prefix} \
      --bindir=%{_bindir} \
      --sbindir=%{_sbindir} \
      --libexecdir=%{_libdir}/apache \
      --mandir=%{_mandir} \
      --localstatedir=%{_localstatedir} \
      --sysconfdir=/etc/httpd/conf \
      --datadir=%{contentdir} \
      --includedir=%{_includedir}/apache \
      --libexecdir=%{_libdir}/apache \
      --iconsdir=%{contentdir}/icons \
      --htdocsdir=%{contentdir}/html \
      --cgidir=%{contentdir}/cgi-bin \
      --runtimedir=%{_var}/httpd \
      --logfiledir=%{_var}/log/httpd \
      --proxycachedir=%{_var}/cache/httpd \
      --enable-module=all \
      --enable-shared=max \
      --enable-rule=EAPI \
      --enable-shared=ssl \
      --enable-suexec \
      --suexec-caller=webd \
      --suexec-uidmin=48 \
      --suexec-gidmin=48


### mod_ssl compiles directly with Apache
cd ../apache_%{version}


APACHE_SRC_DEFAULT=../apache_1.3.14/src make


%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
%{makeinstall} sysconfdir=$RPM_BUILD_ROOT/etc/httpd/conf \
	includedir=$RPM_BUILD_ROOT%{_includedir}/apache \
	libexecdir=$RPM_BUILD_ROOT%{_libdir}/apache \
	iconsdir=$RPM_BUILD_ROOT%{contentdir}/icons \
	htdocsdir=$RPM_BUILD_ROOT%{contentdir}/html \
	cgidir=$RPM_BUILD_ROOT%{contentdir}/cgi-bin \
	runtimedir=$RPM_BUILD_ROOT%{_var}/httpd \
	logfiledir=$RPM_BUILD_ROOT%{_var}/log/httpd \
	proxycachedir=$RPM_BUILD_ROOT%{_var}/cache/httpd \
	manualdir=$RPM_BUILD_ROOT%{contentdir}/html/manual


### Remove apachectl... we have our own SysV init stuff.
rm $RPM_BUILD_ROOT%{_sbindir}/apachectl
rm $RPM_BUILD_ROOT%{_mandir}/man8/apachectl.8


### Install initscript.
mkdir -p $RPM_BUILD_ROOT/etc/init.d
install -m700 %{SOURCE5} $RPM_BUILD_ROOT/etc/init.d/httpd

### Install logrotate script.
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
install -m644 %{SOURCE1} $RPM_BUILD_ROOT/etc/logrotate.d/apache

### Make the configuration/library directories.
mkdir -p $RPM_BUILD_ROOT/usr/lib/apache
mkdir -p $RPM_BUILD_ROOT/etc/httpd/conf

### Create appropriate symlinks.
cd $RPM_BUILD_ROOT/etc/httpd/
ln -sf ../../var/log/httpd logs
ln -sf ../../usr/lib/apache modules

### Install our httpd.conf.
install -m644 %{SOURCE2} $RPM_BUILD_ROOT/etc/httpd/conf/httpd.conf

### Install our "default" index.html.
install -m644 %{SOURCE3} $RPM_BUILD_ROOT%{contentdir}/html/index.html


### Move our perl def from /usr/local/bin/perl to /usr/bin/perl.
find $RPM_BUILD_ROOT -type f | \
	xargs grep -l "/usr/local/bin/perl5" | \
	xargs perl -pi -e "s|/usr/local/bin/perl5|/usr/bin/perl|g;"
find $RPM_BUILD_ROOT -type f | \
	xargs grep -l "/usr/local/bin/perl" | \
	xargs perl -pi -e "s|/usr/local/bin/perl|/usr/bin/perl|g;"


### Remove our build root from apxs.
sed "s^$RPM_BUILD_ROOT^^g" $RPM_BUILD_ROOT%{_sbindir}/apxs > apxs.tmp && \
cat apxs.tmp > $RPM_BUILD_ROOT%{_sbindir}/apxs



%clean
rm -rf $RPM_BUILD_ROOT


%pre
  if [ $1 = 1 ] ; then
	/usr/sbin/useradd -u 48 -r webd > /dev/null 2>&1 || :
  fi


%post
  if [ -f /var/lock/subsys/httpd ]; then
	/etc/init.d/httpd restart || 1;
  fi


%preun
  if [ $1 = 0 ]; then
	/etc/init.d/httpd stop > /dev/null 2>&1
	/sbin/chkconfig --del httpd
  fi


  
%files
%defattr(-,root,root)
%dir /etc/httpd/conf
%attr(0640,root,admin) %config(noreplace) /etc/httpd/conf/httpd.conf

/etc/httpd/logs
/etc/httpd/modules/*

%attr(0640,root,admin) %config /etc/logrotate.d/apache
%attr(0700,root,root) %config /etc/init.d/httpd

%dir %{contentdir}
%dir %{contentdir}/html
%attr(0644,root,root) %{contentdir}/html/index.html

%doc %{_mandir}/man1/*
%doc %{_mandir}/man8/ab.8*
%doc %{_mandir}/man8/httpd.8*
%doc %{_mandir}/man8/logresolve.8*
%doc %{_mandir}/man8/rotatelogs.8*

%attr(0750,root,admin) %{_sbindir}/rotatelogs
%attr(0700,root,root) %{_sbindir}/httpd
%{_sbindir}/ab
%{_sbindir}/logresolve
%{_bindir}/dbmmanage
%{_bindir}/htdigest
%{_bindir}/htpasswd

%attr(-,nobody,nobody) %dir %{_var}/cache/httpd
%dir %attr(750,webd,admin)  %{_var}/log/httpd

%{_sbindir}/suexec
%doc %{_mandir}/man8/suexec.8



%changelog
* Tue Nov 04 2003 Ryan W. Maple <ryan@guardiandigital.com>
- Version 1.3.27, Release 1.0.34
  - Fix buffer overflow which occurs in mod_alias or mod_rewrite
    when a regexp has more then 9 captures.

* Fri Oct 25 2002 Ryan W. Maple <ryan@guardiandigital.com>
- Version 1.3.27, Release 1.0.33
  - Happy birthday mom!
  - Update to mod_ssl 2.8.12 to fix XSS issues.
  - Some some potential attacks on ht{passwd,digest}

* Mon Oct 07 2002 Ryan W. Maple <ryan@guardiandigital.com>
- Version 1.3.27, Release 1.0.32
  - Fix CAN-2002-0839, CAN-2002-0840, and CAN-2002-0843.

* Mon Jul 01 2002 Ryan W. Maple <ryan@guardiandigital.com>
- Version 1.3.26, Release 1.0.31
  - Update to mod_ssl 2.8.10.  This is the proper version for Apache 1.3.26.
  - Fixed date in previous %changelog entry.

* Wed Jun 19 2002 Ryan W. Maple <ryan@guardiandigital.com>
- Version 1.3.26, Release 1.0.30
  - Fix "chunked encoding" vulnerability by upgrading.  Port mod_ssl 2.8.7.

* Mon May 06 2002 Ryan W. Maple <ryan@guardiandigital.com>
- Version 1.3.28, Release 1.0.28
  - Finally fixing the bugs introduced by the last update.

* Thu Feb 28 2002 Ryan W. Maple <ryan@guardiandigital.com>
- Version 1.3.23, Release 1.0.27
  - New mod_ssl, thus new Apache.  Fixes some buffer overflows.
  - Upgraded Apache to 1.3.23 while I was at it.

* Tue Oct 16 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 1.3.20, Release 1.0.26
  - (Please note the previous release, 1.0.99, was an unofficial release
     which some engarde-users are using.  This release is an official build.)
  - New upstream version fixes some more directory disclosure
    vulnerabilities.  New mod_ssl too.
  - New manualdir= Makefile argument.  Use it.
  - Restart apache in %post (if it's currently running).

* Mon Sep 24 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 1.3.20, Release 1.0.99
  - Increased HARD_SERVER_LIMIT for some engarde-users.

* Wed Jun 20 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 1.3.20, Release 1.0.25
  - Update to 1.3.20 to close Mantis ID #00041.

* Tue Mar 27 2001 Ryan W. Maple <ryan@guardiandigital.com>
  - Updated initscripts.

* Thu Mar 15 2001 Ryan W. Maple <ryan@guardiandigital.com>
  - Updated initscripts.

* Wed Feb 14 2001 Pete O'Hara <pete@guardiandigital.com>
- added Source5: httpd.init

* Tue Jan 16 2001 Nick DeClario <nick@guardiandigital.com>
- Added mkstemp patch

* Tue Jan 09 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 1.3.14, Release 1.0.16
  - Playing with suexec to fix the apache file access problem...

* Fri Dec 29 2000 Ryan W. Maple <ryan@guardiandigital.com>
- Version 1.3.14, Release 1.0.15
  - Rebuilt with pthreads to fix php issues *yippie*.
  - PHP Bug ID #8298

* Fri Dec 15 2000 Nick DeClario <nick@guardiandigital.com>
- chown webd.admin to /var/log/httpd

* Thu Dec 07 2000 Pete OHara <pete@guardiandigital.com>
- chmod 640 /etc/logrotate.d/apache, /etc/httpd/conf/httpd.conf

* Sun Dec 03 2000 Ryan W. Maple <ryan@guardiandigital.com>
- Version 1.3.14, Release 1.0.10
  - Made final changes to httpd.conf

* Sat Dec 02 2000 Ryan W. Maple <ryan@guardiandigital.com>
- Version 1.3.14, Release 1.0.9
  - General overhaul of spec file.
  - Fixed modssl inclusion. (--enable-shared=ssl)
  - Added our new and improved httpd.conf
  - Removed icons directory.
  - "Default" site now goes to a blank page.
  - Removed addition of 'htm' to /etc/mime.types since it's already there.
  - Removed usage of "/etc/serivce" for "/etc/init.d/httpd" in post-removal.
  - Removed ssl keys and 'make certificate' lines, they're unnecessary.
  - Sanitized various permissions.

* Sat Dec 02 2000 Pete OHara <pete@guardiandigital.com>
- changed /var/log/httpd to 750 root,admin

* Fri Dec 01 2000 Dave Wreski <dave@guardiandigital.com>
- fixed /etc/httpd/ssl.crt to /etc/httpd/conf/ssl.crt
- fixed /etc/httpd/ssl/key to /etc/httpd/conf/ssl.key
- fixed sysconfdir to /etc

* Thu Nov 29 2000 Nick DeClario <nick@guardiandigital.com>
- Upgraded Apache to 1.3.14
- Upgraded mod_ssl to 2.7.1
- Changed permissions for logrotate

* Sat Nov 25 2000 Dave Wreski <dave@guardiandigital.com>
- changed ownership of http conf files
- added (noreplace)

* Thu Nov 16 2000 Nick DeClario <nick@guardiandigital.com> 
- In process of working with it, do not edit

* Wed Nov 15 2000 Ryan W. Maple <ryan@guardiandigital.com>
- Made various changes to httpd.conf

* Mon Oct 27 2000 Nick DeClario <nick@guardiandigital.com>
- Fixed initscript LIDS compatibility problem

* Mon Oct 02 2000 Nick DeClario <nick@guardiandigital.com>
- Fixed missing libssl.so file

* Tue Sep 19 2000 Nick DeClario <nick@guardiandigital.com>
- Removed unnecessary openSSL sources for faster compiling
- fixed some linking errors
- removed unnecessary patches

* Thu Jul 14 2000 Nick DeClario <nick@guardiandigital.com>
- added SSL via OpenSSL and Mod_SSL
